/* -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
 *
 * This file is part of the UPPAAL DBM library.
 *
 * The UPPAAL DBM library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * The UPPAAL DBM library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with the UPPAAL DBM library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301  USA.
 */

// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; indent-tabs-mode: nil; -*-
////////////////////////////////////////////////////////////////////
//
// Filename : slist.h (base)
//
// Wrapped include to the right slist: do all the nasty tests.
//
// This file is a part of the UPPAAL toolkit.
// Copyright (c) 1995 - 2003, Uppsala University and Aalborg University.
// All right reserved.
//
// $Id: slist.h,v 1.1 2004/01/22 10:53:52 adavid Exp $
//
///////////////////////////////////////////////////////////////////

#ifndef INCLUDE_BASE_SLIST_H
#define INCLUDE_BASE_SLIST_H

#include "config.h"

#ifdef HAVE_SLIST
#  include <slist>
#else
#  ifdef HAVE_EXT_SLIST
#    include <ext/slist>
#  else
#    include <list>
#    define slist list
#  endif
#endif

#ifdef CXX_SLIST_NAMESPACE
namespace std
{
  using CXX_SLIST_NAMESPACE::slist;
}
#endif

#endif // INCLUDE_BASE_SLIST_H
